<?php

$mode = "";         // CSSモード
$file_name = "";    // CSSファイル名
$contents = "";     // CSSファイルの中身

$ua_string = $_SERVER["HTTP_USER_AGENT"];
if (preg_match("/Gecko\/200[3-9]/i", $ua_string)) {
    $file_name = "/template/rr103_base.css";
} elseif (preg_match("/Opera[\s\/]7/", $ua_string)) {
    $file_name = "/template/rr103_opera7.css";
} elseif (preg_match("/Safari/i", $ua_string)) {
    $file_name = "/template/rr103_safari.css";
} elseif (preg_match("/MSIE 6/", $ua_string)) {
    $file_name = "/template/rr103_ie6.css";
} else {
    $file_name = "/template/simple.css";
}

$request_headers = apache_request_headers();
$time_newest = filemtime($_SERVER["DOCUMENT_ROOT"] . $file_name);

header("Content-Type: text/css");
header("Last-Modified: " . gmdate("D, d M Y H:i:s", filemtime($_SERVER["DOCUMENT_ROOT"] . $file_name)) . " GMT");
header("Vary: User-Agent");

if( $request_headers["If-Modified-Since"] ) {
    $since = parse_http_date( $request_headers["If-Modified-Since"] );
    if( $since["timestamp"] >= $time_newest ) {
        header( "HTTP/1.1 304 Not Modified" );
        exit();
    }
}

print file_get_contents($_SERVER["DOCUMENT_ROOT"] . $file_name);

function parse_http_date( $string_date ) {

    // 月の名前と数字を定義
    $define_month = array(
        "01" => "Jan", "02" => "Feb", "03" => "Mar",
        "04" => "Apr", "05" => "May", "06" => "Jun",
        "07" => "Jul", "08" => "Aug", "09" => "Sep",
        "10" => "Oct", "11" => "Nov", "12" => "Dec"
    );

    if( preg_match( "/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun), ([0-3][0-9]) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-9]{4}) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) GMT$/", $string_date, $temp_date ) ) {

        $date["hour"] = $temp_date[5];
        $date["minute"] = $temp_date[6];
        $date["second"] = $temp_date[7];
        // 定義済みの月の名前を数字に変換する
        $date["month"] = array_search( $temp_date[3], $define_month );
        $date["day"] = $temp_date[2];
        $date["year"] = $temp_date[4];


    } elseif( preg_match( "/^(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday), ([0-3][0-9])-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-([0-9]{2}) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) GMT$/", $string_date, $temp_date ) ) {

        $date["hour"] = $temp_date[5];
        $date["minute"] = $temp_date[6];
        $date["second"] = $temp_date[7];
        // 定義済みの月の名前を数字に変換する
        $date["month"] = array_search( $temp_date[3], $define_month );
        // 年が2桁しかないので1900を足して4桁に
        $date["day"] = $temp_date[2];
        $date["year"] = 1900 + $temp_date[4];


    } elseif( preg_match( "/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-3 ][0-9]) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) ([0-9]{4})$/", $string_date, $temp_date ) ) {
        $date["hour"] = $temp_date[4];
        $date["minute"] = $temp_date[5];
        $date["second"] = $temp_date[6];
        $date["month"] = array_search( $temp_date[2], $define_month );
        // 日が1桁の場合先、半角スペースを0に置換
        $date["day"] = str_replace( " ", 0, $temp_date[3] );
        // 定義済みの月の名前を数字に変換する
        $date["year"] = $temp_date[7];


    } else {
        return FALSE;
    }

    // UNIXタイムスタンプを生成GMTなのに注意
    $date["timestamp"] = gmmktime( $date["hour"], $date["minute"], $date["second"], $date["month"], $date["day"], $date["year"] );

    return $date;
}

?>