<?php
abstract class Xmb_DataManager {
    private $itemContainer = NULL;

    public function __construct() {
        $this->itemContainer = new Xmb_ItemContainer();
    }

    public function getItem($id) {
        try {
            $dataStr = $this->loadData($id);
            $dataDom = new DomDocument();
            $dataDom->loadXML($dataStr);
            $anItem = clone $this->itemContainer;
            $anItem->setRawData($dataDom);
            return $anItem;
        } catch (Xmb_DataNotFoundException $e) {
            return $e;
        }
    }

    abstract protected function loadData($id);

    public function saveItem(Xmb_ItemStructure $item) {
        $this->writeData($item->getRawData());
    }

    abstract public function getItemList();
}
?>