<?php
class Xmb_DataManagerFileSystem extends Xmb_DataManager {
    private $dataDirectory = "./Data";

    public function loadData($id) {
        if (file_exists($this->dataDirectory . "/" . $id . ".xml")) {
            return file_get_contents($this->dataDirectory . "/" . $id . ".xml");
        } else {
            throw new Xmb_DataNotFoundException($id);
        }
    }

    public function writeData(DomDocument $data) {
        $xp = new DomXpath($data);
        $xp->registerNameSpace("i", "http://www.arielworks.net/works/codeyard/xms");
        $idNL = $xp->query("/i:item/@id[1]");
        $id = $idNL->item(0)->value;
        $dom->save($this->dataDirectory . "/" . $id . ".xml");
    }

    public function getItemList() {
        $itemList = array();
        $dataDir = dir($this->dataDirectory);
        while (FALSE !== ($entry = $dataDir->read())) {
            if (preg_match("/^(\d+)\.xml$/", $entry, $currentNum)) {
                $itemList[] = $currentNum[1];
            }
        }
        return $itemList;
    }
}
?>