<?php
require_once "../himmel/Himmel_Himmel.php";

class Xmb_XmlMessageBoard {

    public function showLatestItems($number) {
        $dm = new Xmb_DataManagerFileSystem();
        $itemList = $dm->getItemList();
        rsort($itemList);
        $itemList = array_chunk($itemList, $number);
        $itemList = $itemList[0];

        $itemSdfList = array();
        if ($itemList) {
            foreach ($itemList as $anItem) {
                $anItemCtn =  $dm->getItem($anItem);
                $itemSdfList[] = $this->transformItemToSdf($anItemCtn, TRUE);
            }
        } else {
            //errorrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
        }

        $resultSdf = new DomDocument();

        $himmel = new Himmel_Himmel();
        $dc = $himmel->getDataContainer();
        foreach ($itemSdfList as $anItemSdf) {
            $dc->appendBodyData($anItemSdf->firstChild);
        }
        $dcCrtdList = $itemSdfList[0]->getElementsByTagName("created");
        $dc->setCreatedDatetime($itemSdfList[0]->saveXML($dcCrtdList->item(0)->firstChild));
        $dc->setTitle(new DomText("Latest " . $number .  " items"));
        $himmel->excute($dc);

    }

    private function transformItemToSdf(Xmb_ItemContainer $itemContainer, $flagment = FALSE) {
        $xsltp = new XsltProcessor();
        $domXsl = new DomDocument();
        if ($fragment) {
            $domXsl->load("ItemToSdfFragment.xsl");
        } else {
            $domXsl->load("ItemToSdf.xsl");
        }
        $xsltp->importStyleSheet($domXsl);
        return $xsltp->transformToDoc($itemContainer->getRawData());
    }

    public function showItemById($itemNumber) {
        $dm = new Xmb_DataManagerFileSystem();
        try {
            $ic = $dm->getItem($itemNumber);
        } catch(Xmb_DataNotFoundException $e) {
            // error
            print "Error";
        }
        $himmel = new Himmel_Himmel();
        $dc = $himmel->getDataContainer();
        $dc->setData($this->transformItemToSdf($ic));
        $himmel->excute($dc);
    }

    public function showItemList() {
        $dc = PxbUtil::getDataController();
        $itemList = $dc->getItemList();
        rsort($itemList);

        $itemObjectList = array();
        if ($itemList) {
            foreach ($itemList as $anItem) {
                $itemObjectList[] = $dc->loadData($anItem);
            }
        } else {
            $emptyMsg = PxbUtil::getItemStructure();
            $emptyMsg->setTitle("No Item");
            $emptyMsg->setBody("No item posted");
            $itemObjectList[] = $emptyMsg;
        }

        $of = PxbUtil::getOutputFormatter();
        $of->outputItemList($itemObjectList);
    }

    public function postItem() {
        $title   = htmlspecialchars($_POST["title"]);
        $body = mbhtmlspecialchars($_POST["body"], ENT_COMPAT, "UTF-8");

        $dc = PxbUtil::getDataController();
        $existItemsList = $dc->getItemList();
        if (count($existItemsList) != 0) {
            $existItemIdMax = $existItemsList[count($existItemsList) - 1];
            $newItemId =  $existItemIdMax + 1;

            if ($body == $dc->loadData($newItemId - 1)->getBody()) {
                print "Error: Same Massage Body"; // !!!!!!
                die();
            }
        } else {
            $newItemId = 1;
        }

        if ($title == "") {
            $title = "Item" . $newItemId;
        }

        if ($body == "") {
			print "Error"; // !!!!!!
            die();
		}

        $is = $dc->createItem();
        $is->setId($newItemId);
        $is->setTitle($title);
            $enableRules = array(
                "Prefilter",
                "Anchor",
                "Blockquote",
                "Code",
                "Deflist",
                "Emphasis",
                "List",
                "Paragraph",
                "Raw",
                "Revise",
                "Strong",
                "Table",
                "Url"
            );
            $tw = new Text_Wiki($enableRules);
            $bodyDom = new DomDocument();
            $bodyDom->loadXML($tw->transform($aPost->getBody(), "xhtml"));
            $bodyXp = new DomXpath($bodyDom);
            $this->registerBasicNameSpaces($bodyXp);
            $nodesInMassageBodyList = $bodyXp->query("/node()");
            foreach ($nodesInMassageBodyList as $nodesInMassageBody) {
                $bodyNode->appendChild($dom->importNode($nodesInMassageBody, TRUE));
            }        $is->setBody($body);
        $is->setDate(date("Y-m-d\TH:i:s") . substr(date("O"), 0, 3) . ":" . substr(date("O"), 3));

        $dc = PxbUtil::getDataController();
        $dc->saveData($is);

        header("Location: ./latest");

    }
}
?>